#ifndef __EC_IO_H__
#define __EC_IO_H__
#include <linux/io.h>
#include <linux/delay.h>
#include <asm/phytium_platform.h>

#define TIMEDELAY           10

/* 1 = Input buffer full (data ready for ec) */
#define EC_IBF				(1 << 1)
/* 1 = Output buffer full (data ready for host) */
#define EC_OBF				(1 << 0)


/*
 * the default ec port value,some boards may should modified the value
 */
#define EC_CMD_PORT 0x28
#define EC_DAT_PORT 0x20

/*
 * ACPI legacy commands.
 */
/* Read EC command */
#define CMD_READ_EC				0x80
/* Write EC command */
#define CMD_WRITE_EC			0x81
/* Query EC command, for get SCI event number */
#define CMD_GET_EVENT_NUM		0x84

#define MASK(x)					(1 << x)

unsigned char ec_ch_read(unsigned char index);

#endif
