#ifndef __EC_IO_H__
#define __EC_IO_H__
#include <linux/io.h>
#include <linux/delay.h>
#include <asm/phytium_platform.h>

#define TIMEDELAY		10

/* 1 = Input buffer full */
#define EC_IBF			(1 << 1)
/* 1 = Output buffer full */
#define EC_OBF			(1 << 0)


/*
 * the default ec port value,some boards may should modified the value
 */
#define CZC_EC_CMD_PORT		0x198
#define CZC_EC_STS_PORT		0x188
#define CZC_EC_DAT_PORT		0x188

/* ACPI legacy commands */
/* Read EC command. */
#define CMD_READ_EC				0x80
/* Write EC command. */
#define CMD_WRITE_EC			0x81
/* Query EC command. */
#define CMD_GET_EVENT_NUM		0x84

#define MASK(x)		(1 << x)

unsigned char czc_ec_read(unsigned char index);
void czc_ec_write(unsigned char index, unsigned char data);

#endif
