#ifndef __PHYPIUM_PLATFORM__
#define __PHYPIUM_PLATFORM__

#include <asm/cputype.h>

/********************* for all Phytium CPUs ******************/
static inline bool is_part(u32 cpuid)
{
	return ((read_cpuid_id() & MIDR_CPU_MODEL_MASK) == cpuid);
}

static inline bool is_implementer(u32 implementer)
{
	return ((read_cpuid_implementor() == implementer));
}

/* Phytium LPC */
extern void __iomem *lpc_base;
extern int lpc_irq;

extern u8 ft_lpc_read(u8 addr);
extern u8 ft_lpc_write(u8 value, u8 addr);

#define PHYTIUM_LPC_SIRQ_BIT_KBD	1
#define PHYTIUM_LPC_SIRQ_BIT_EC		11
#define PHYTIUM_LPC_SIRQ_BIT_AUX	12

extern int phytium_lpc_irq_find_mapping(u32 offset);

#ifdef CONFIG_FT_PINMUX
int ft_pinmux_select_gpio(int gpio);
#endif

#endif
