/* SPDX-License-Identifier: GPL-2.0 */
/*
 * SICH Bridge Related Definitions
 */

#ifndef _ASM_SW64_SICH_H
#define _ASM_SW64_SICH_H

/* Device switches based on AMBA bridge of SICH */
enum MSISWCfgBase_OF_SICH {
	PS2KB_OF_SICH	= 0x004,
	PS2MO_OF_SICH	= 0x008,
	UART_OF_SICH	= 0x00c,
	GPIO_OF_SICH	= 0x010,
	LPC_OF_SICH	= 0x014,
	XHCI_OF_SICH	= 0x018,
	I2C0_OF_SICH	= 0x01c,
	I2C2_OF_SICH	= 0x024,
	GMAC0_OF_SICH	= 0x028,
	GMAC1_OF_SICH	= 0x02c,
	SATA_OF_SICH	= 0x030,
	GPU_OF_SICH	= 0x034,
	VPU_OF_SICH	= 0x038,
	DC_OF_SICH	= 0x03c,
	DMA_OF_SICH	= 0x040,
	AC97_OF_SICH	= 0x044,
	I2C1_OF_SICH	= 0x048,
	SPI_OF_SICH	= 0x04c,
};

extern unsigned long sich_bridge_addr;
extern unsigned long sich_spi_addr;

#endif	/* _ASM_SW64_SICH_H */
