/* SPDX-License-Identifier: GPL-2.0 */
/*
 * include/linux/blk-load.h
 */
#ifndef BLK_LOAD_H
#define BLK_LOAD_H

#include <linux/blkdev.h>
/*
 * ideally for global io speed up usage
 * so deine in global include/linux dir
 */
/* IO boost mode */
enum IO_MODE {
	IO_NORMAL = 0,
	IO_BOOST_READ,
	IO_BOOST_WRITE,
};
#ifdef	CONFIG_BLK_LOAD
/* blk load mode get */
int blk_load_mode_get(void);

/* blk load mode init */
int blk_load_init(struct request_queue *q);
#else /* CONFIG_BLK_LOAD */
static inline int blk_load_mode_get(void)
{
	return IO_NORMAL;
}

static inline int blk_load_init(struct request_queue *q)
{
	return IO_NORMAL;
}
#endif /* CONFIG_BLK_LOAD */
#endif /* BLK_LOAD_H */
