########################################################################### ###
#@Copyright     Copyright (c) Imagination Technologies Ltd. All Rights Reserved
#               Additional changes in this file are
#               Copyright (c) Innosilicon Technology Ltd. All Rights Reserved
#@License       Dual MIT/GPLv2
#
# The contents of this file are subject to the MIT license as set out below.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# Alternatively, the contents of this file may be used under the terms of
# the GNU General Public License Version 2 ("GPL") in which case the provisions
# of GPL are applicable instead of those above.
#
# If you wish to allow use of your version of this file only under the terms of
# GPL, and not to allow others to use your version of this file under the terms
# of the MIT license, indicate your decision by deleting the provisions above
# and replace them with the notice and other provisions required by GPL as set
# out in the file called "GPL-COPYING" included in this distribution. If you do
# not delete the provisions above, a recipient may use your version of this file
# under the terms of either the MIT license or GPL.
#
# This License is also included in this distribution in the file called
# "MIT-COPYING".
#
# EXCEPT AS OTHERWISE STATED IN A NEGOTIATED AGREEMENT: (A) THE SOFTWARE IS
# PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
# BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
# PURPOSE AND NONINFRINGEMENT; AND (B) IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
### ###########################################################################

modules := adf_pdp tc drm_nulldisp drm_pdp plato drm_rk drm_pdp2_hdmi cdma loki \
	innogpu  innoaudio innodpu innoaxidmatest innodma innodmatest innoregslog \
	innodma_api_test innopciedmatest innovpu  vha  vhainfo imgmem gpu_info
	
ifeq ($(SUPPORT_ION),1)
modules += ion

ion_type := kernel_module
ion_target := ion.ko
ion_makefile := $(THIS_DIR)/innogpu/ion_drv/Kbuild.mk

endif

adf_pdp_type := kernel_module
adf_pdp_target := adf_pdp.ko
adf_pdp_makefile := $(THIS_DIR)/Kbuild.mk

tc_type := kernel_module
tc_target := tc.ko
tc_makefile := $(THIS_DIR)/Kbuild.mk

drm_nulldisp_type := kernel_module
drm_nulldisp_target := drm_nulldisp.ko
drm_nulldisp_makefile := $(THIS_DIR)/Kbuild.mk

drm_pdp_type := kernel_module
drm_pdp_target := drm_pdp.ko
drm_pdp_makefile := $(THIS_DIR)/Kbuild.mk

drm_pdp2_hdmi_type := kernel_module
drm_pdp2_hdmi_target := drm_pdp2_hdmi.ko
drm_pdp2_hdmi_makefile := $(THIS_DIR)/Kbuild.mk

plato_type := kernel_module
plato_target := plato.ko
plato_makefile := $(THIS_DIR)/Kbuild.mk

drm_rk_type := kernel_module
drm_rk_target := drm_rk.ko
drm_rk_makefile := $(THIS_DIR)/Kbuild.mk

cdma_type := kernel_module
cdma_target := cdma.ko
cdma_makefile := $(THIS_DIR)/Kbuild.mk

loki_type := kernel_module
loki_target := loki.ko
loki_makefile := $(THIS_DIR)/Kbuild.mk

innogpu_type := kernel_module
innogpu_target := innogpu.ko
innogpu_makefile := $(THIS_DIR)/innogpu/Kbuild.mk

innovpu_type := kernel_module
innovpu_target := innovpu.ko
innovpu_makefile := $(THIS_DIR)/innogpu/Kbuild.mk

innoaudio_type		:= kernel_module
innoaudio_target	:= innoaudio.ko
innoaudio_makefile	:= $(THIS_DIR)/innogpu/Kbuild.mk

innodpu_type := kernel_module
innodpu_target := innodpu.ko
innodpu_makefile := $(THIS_DIR)/innogpu/Kbuild.mk

innoaxidmatest_type := kernel_module
innoaxidmatest_target := innoaxidmatest.ko
innoaxidmatest_makefile := $(THIS_DIR)/innogpu/Kbuild.mk

innodma_type := kernel_module
innodma_target := innodma.ko
innodma_makefile := $(THIS_DIR)/innogpu/Kbuild.mk

innodmatest_type := kernel_module
innodmatest_target := innodmatest.ko
innodmatest_makefile := $(THIS_DIR)/innogpu/Kbuild.mk

innodma_api_test_type := kernel_module
innodma_api_test_target := innodma_api_test.ko
innodma_api_test_makefile := $(THIS_DIR)/innogpu/Kbuild.mk

innoregslog_type := kernel_module
innoregslog_target := innoregslog.ko
innoregslog_makefile := $(THIS_DIR)/innogpu/Kbuild.mk

innopciedmatest_type := kernel_module
innopciedmatest_target := innopciedmatest.ko
innopciedmatest_makefile := $(THIS_DIR)/innogpu/Kbuild.mk

gpu_info_type := kernel_module
gpu_info_target := gpu_info.ko
gpu_info_makefile := $(THIS_DIR)/innogpu/tools/gpu_info/Kbuild.mk

vha_type := kernel_module
vha_target := vha.ko
vha_makefile := $(THIS_DIR)/innogpu/Kbuild.mk

vhainfo_type := kernel_module
vhainfo_target := vhainfo.ko
vhainfo_makefile := $(THIS_DIR)/innogpu/Kbuild.mk

imgmem_type := kernel_module
imgmem_target := imgmem.ko
imgmem_makefile := $(THIS_DIR)/innogpu/Kbuild.mk