#- Different project has different config, for example, the gnr encoder project
#- doesn't have mmu, so this file is used to list the certain value of those   
#- variables about different projects. When the variable equal to y, means it 
#- must be used in fpga, when it equal to n, means it didn't have this feature,
#- and when it equal to a value by ?=, means it supports this feature, and can
#- change it to y or n as test needed. so this file is a reference file in a sense,
#- and it should be updated when has an new project.
#-------------------------------------------------------------------------------
#-----------------------------------------------------------------------------*/
ifeq ($(strip $(target)),gnr_dec)
FPGA := y
SIMICS := n
VSI_VC8000E := n
VSI_VC8000D := y
VSI_VCMD ?= n
VSI_CACHE ?= n
VSI_DEC400 ?= n
VSI_MMU := n # doesn't support mmu
VSI_AXIFE := y
endif

ifeq ($(strip $(target)),gnr_enc)
FPGA := y
SIMICS := n
VSI_VC8000E := y
VSI_VC8000D := n
VSI_VCMD ?= n
VSI_CACHE := n # doesn't support L2cache
VSI_DEC400 ?= n
VSI_MMU := n # doesn't support mmu
VSI_AXIFE := y
endif

ifeq ($(strip $(target)),oyb_dec)
FPGA := y
SIMICS := n
VSI_VC8000E := n
VSI_VC8000D := y
VSI_VCMD ?= n
VSI_CACHE ?= n
VSI_DEC400 ?= n
VSI_MMU ?= n
VSI_AXIFE := y
endif

ifeq ($(strip $(target)),oyb_enc)
FPGA := y
SIMICS := n
VSI_VC8000E := y
VSI_VC8000D := n
VSI_VCMD ?= n
VSI_CACHE := n
VSI_DEC400 ?= n
VSI_MMU ?= n
VSI_AXIFE := y
endif