#!/bin/bash

###################### MERGE SOURCE TREE  ##########################

if [ $# -lt 1 ]; then
	echo "请输入源分支"
	exit
fi

git reset --hard
THIS_BRANCH=`git branch | grep "*"  | awk -F' ' '{print $2}'`

git checkout -b my_test --force

LAST_VERSION=`git log  -n 1  --pretty="%H" Makefile`
SRC_BRANCH=$1

# 展开合并
git merge $SRC_BRANCH

# 提交合并
COMMIT_MSG=`git shortlog HEAD...${LAST_VERSION}`

git checkout $THIS_BRANCH --force

git merge --no-commit --no-ff $SRC_BRANCH
git commit -s -m "Merge branch $SRC_BRANCH into $THIS_BRANCH

$COMMIT_MSG
"
git branch -D my_test

###################### UPDATE KERNEL VERSION ##########################

# 更新 Makefile 的版本信息
V=`sed -n 's/^EXTRAVERSION = -//p' Makefile`
BV=`sed -n 's/^KYLIN_BUILD_VERSION = //p' Makefile`

let NOW=$((V))+1
let BV_NOW=$((BV))+1

sed -i "/EXTRAVERSION =/d" Makefile
sed -i "/SUBLEVEL =/aEXTRAVERSION = -${NOW}" Makefile
sed -i "/KYLIN_BUILD_VERSION =/d" Makefile
sed -i "/EXTRAVERSION =/aKYLIN_BUILD_VERSION = ${BV_NOW}" Makefile

VERSION=`sed -n 's/^VERSION = //p' Makefile`
PATCHLEVEL=`sed -n 's/^PATCHLEVEL = //p' Makefile`
SUBLEVEL=`sed -n 's/^SUBLEVEL = //p' Makefile`

TEMPFILE="/tmp/.changelog"

# 新增 Deb changelog 信息
echo "linux (${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}.${BV_NOW}) v101; urgency=low" > $TEMPFILE
echo "" >> $TEMPFILE
git log HEAD...${LAST_VERSION} --pretty=oneline --pretty="format:  * [%h]" >> $TEMPFILE
echo "" >> $TEMPFILE
echo "" >> $TEMPFILE
echo " -- Ke Sun <sunke@kylinos.cn>  `date -R`" >> $TEMPFILE
echo "" >> $TEMPFILE
cat debian.master/changelog >> $TEMPFILE
\mv $TEMPFILE debian.master/changelog

git commit -s -am  "Update kernel version to ${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}.${BV_NOW}

更新内核至 ${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}.${BV_NOW}"
